/*
**	Test main program for MS-DOS diskette routines: delete file
*/

#include	<stdio.h>

#include	"io.h"
#include	"msdos.h"

main(argc,argv)
int argc;
char *argv[];	{
	register int i,j;
	directory *dp;
	FILE *f=stdin;

	if(argc!=3)	{
		printf(	"usage: write diskette_file [other_file|-]\n"
			"Diskette filename may have leading A: B: or\n"
			"imbedded periods, indicating spaces\n");
		exit(2);
	}

	if((*argv[2]!='-' || argv[2][1]) && (!(f=fopen(argv[2],"r"))))	{
		printf("Cannot open file \"%s\" for reading\n",argv[2]);
		exit(1);
	}

	for(i=0; j=argv[1][i]; i++)
		if(j=='.')
			argv[1][i] = ' ';
		else if(j>='a' && j<='z')
			argv[1][i] -= 32;
	if(argv[1][1]==':')	{
		drive_number = *argv[1]-'A';
		argv[1] += 2;
	}

	disk_open();

	if(dp=file_create(argv[1]))
		printf("Created file \"%s\"\n",argv[1]);
	else	{
		printf("Could not create file \"%s\"\n",argv[1]);
		exit(1);
	}

	while((i=getc(f))!=EOF)
		file_putc(dp,i);

	file_close(dp);
	fclose(f);
	exit(0);
}
